## cubeb 0.0~git20211015.d512bfa+ds

=== CMakeLists.txt ===
# TODO
# - backend selection via command line, rather than simply detecting headers.

cmake_minimum_required(VERSION 3.1 FATAL_ERROR)
project(cubeb
  VERSION 0.0.0)

option(BUILD_SHARED_LIBS "Build shared libraries" OFF)
option(BUILD_TESTS "Build tests" ON)
option(BUILD_RUST_LIBS "Build rust backends" OFF)
option(BUILD_TOOLS "Build tools" ON)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
      "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

if(POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW)
endif()
set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(NOT COMMAND add_sanitizers)
  list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/sanitizers-cmake/cmake")
  find_package(Sanitizers)
  if(NOT COMMAND add_sanitizers)
    message(FATAL_ERROR "Could not find sanitizers-cmake: run\n\tgit submodule update --init --recursive\nin base git checkout")
  endif()
endif()

if(BUILD_TESTS)
  if(NOT TARGET gtest_main)
    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/googletest/CMakeLists.txt")
      message(FATAL_ERROR "Could not find googletest: run\n\tgit submodule update --init --recursive\nin base git checkout")
    endif()
    add_definitions(-DGTEST_HAS_TR1_TUPLE=0 -DGTEST_HAS_RTTI=0)
    set(gtest_force_shared_crt ON CACHE BOOL "")
    add_subdirectory(googletest)
  endif()
endif()

if (BUILD_RUST_LIBS)
  if(EXISTS "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs")
    set(USE_PULSE_RUST 1)
  endif()
  if(EXISTS "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs")
    set(USE_AUDIOUNIT_RUST 1)
  endif()
endif()

# On OS/2, visibility attribute is not supported.
if(NOT OS2)
  set(CMAKE_C_VISIBILITY_PRESET hidden)
  set(CMAKE_CXX_VISIBILITY_PRESET hidden)
  set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
endif()

set(CMAKE_CXX_WARNING_LEVEL 4)
if(NOT MSVC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-unused-parameter")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -fno-exceptions -fno-rtti")
else()
  string(REPLACE "/GR" "" CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS}) # Disable RTTI
  string(REPLACE "/EHsc" "" CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS}) # Disable Exceptions
endif()

add_library(cubeb
  src/cubeb.c
  src/cubeb_mixer.cpp
  src/cubeb_resampler.cpp
  src/cubeb_log.cpp
  src/cubeb_strings.c
  src/cubeb_utils.cpp
   $<TARGET_OBJECTS:speex>)
target_include_directories(cubeb
  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>
)
target_include_directories(cubeb PRIVATE src)
target_compile_definitions(cubeb PRIVATE OUTSIDE_SPEEX)
target_compile_definitions(cubeb PRIVATE FLOATING_POINT)
target_compile_definitions(cubeb PRIVATE EXPORT=)
target_compile_definitions(cubeb PRIVATE RANDOM_PREFIX=speex)

add_sanitizers(cubeb)

include(GenerateExportHeader)
generate_export_header(cubeb EXPORT_FILE_NAME ${CMAKE_BINARY_DIR}/exports/cubeb_export.h)
target_include_directories(cubeb
  PUBLIC $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/exports>
)

if(UNIX)
  include(GNUInstallDirs)
else()
  set(CMAKE_INSTALL_LIBDIR "lib")
  set(CMAKE_INSTALL_BINDIR "bin")
  set(CMAKE_INSTALL_DATADIR "share")
  set(CMAKE_INSTALL_DOCDIR "${CMAKE_INSTALL_DATADIR}/doc")
  set(CMAKE_INSTALL_INCLUDEDIR "include")
endif()

install(DIRECTORY ${CMAKE_SOURCE_DIR}/include/${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(DIRECTORY ${CMAKE_BINARY_DIR}/exports/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
  COMPATIBILITY SameMajorVersion
)

configure_package_config_file(
  "Config.cmake.in"
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
  INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

install(TARGETS cubeb
  EXPORT "${PROJECT_NAME}Targets"
  DESTINATION ${CMAKE_INSTALL_PREFIX}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)
install(
  FILES "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake" "${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)
install(
  EXPORT "${PROJECT_NAME}Targets"
  NAMESPACE "${PROJECT_NAME}::"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

add_library(speex OBJECT
  src/speex/resample.c)
set_target_properties(speex PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
target_compile_definitions(speex PRIVATE OUTSIDE_SPEEX)
target_compile_definitions(speex PRIVATE FLOATING_POINT)
target_compile_definitions(speex PRIVATE EXPORT=)
target_compile_definitions(speex PRIVATE RANDOM_PREFIX=speex)

include(CheckIncludeFiles)

check_include_files(AudioUnit/AudioUnit.h USE_AUDIOUNIT)
if(USE_AUDIOUNIT)
  target_sources(cubeb PRIVATE
    src/cubeb_audiounit.cpp
    src/cubeb_osx_run_loop.cpp)
  target_compile_definitions(cubeb PRIVATE USE_AUDIOUNIT)
  target_link_libraries(cubeb PRIVATE "-framework AudioUnit" "-framework CoreAudio" "-framework CoreServices")
endif()

check_include_files(pulse/pulseaudio.h USE_PULSE)
if(USE_PULSE)
  target_sources(cubeb PRIVATE
    src/cubeb_pulse.c)
  target_compile_definitions(cubeb PRIVATE USE_PULSE)
  target_link_libraries(cubeb PRIVATE pthread ${CMAKE_DL_LIBS})
endif()

check_include_files(alsa/asoundlib.h USE_ALSA)
if(USE_ALSA)
  target_sources(cubeb PRIVATE
    src/cubeb_alsa.c)
  target_compile_definitions(cubeb PRIVATE USE_ALSA)
  target_link_libraries(cubeb PRIVATE pthread ${CMAKE_DL_LIBS})
endif()

check_include_files(jack/jack.h USE_JACK)
if(USE_JACK)
  target_sources(cubeb PRIVATE
    src/cubeb_jack.cpp)
  target_compile_definitions(cubeb PRIVATE USE_JACK)
  target_link_libraries(cubeb PRIVATE pthread ${CMAKE_DL_LIBS})
endif()

check_include_files(audioclient.h USE_WASAPI)
if(USE_WASAPI)
  target_sources(cubeb PRIVATE
    src/cubeb_wasapi.cpp)
  target_compile_definitions(cubeb PRIVATE USE_WASAPI)
  target_link_libraries(cubeb PRIVATE avrt ole32)
endif()

check_include_files("windows.h;mmsystem.h" USE_WINMM)
if(USE_WINMM)
  target_sources(cubeb PRIVATE
    src/cubeb_winmm.c)
  target_compile_definitions(cubeb PRIVATE USE_WINMM)
  target_link_libraries(cubeb PRIVATE winmm)
endif()

check_include_files(SLES/OpenSLES.h USE_OPENSL)
if(USE_OPENSL)
  target_sources(cubeb PRIVATE
    src/cubeb_opensl.c
    src/cubeb-jni.cpp)
  target_compile_definitions(cubeb PRIVATE USE_OPENSL)
  target_link_libraries(cubeb PRIVATE OpenSLES)
endif()

check_include_files(sys/soundcard.h HAVE_SYS_SOUNDCARD_H)
if(HAVE_SYS_SOUNDCARD_H)
  try_compile(USE_OSS "${PROJECT_BINARY_DIR}/compile_tests"
    ${PROJECT_SOURCE_DIR}/cmake/compile_tests/oss_is_v4.c)
  if(USE_OSS)
    target_sources(cubeb PRIVATE
      src/cubeb_oss.c)
    target_compile_definitions(cubeb PRIVATE USE_OSS)
    target_link_libraries(cubeb PRIVATE pthread)
  endif()
endif()

check_include_files(aaudio/AAudio.h USE_AAUDIO)
if(USE_AAUDIO)
  target_sources(cubeb PRIVATE
    src/cubeb_aaudio.cpp)
  target_compile_definitions(cubeb PRIVATE USE_AAUDIO)

  # set this definition to enable low latency mode. Possibly bad for battery
  target_compile_definitions(cubeb PRIVATE CUBEB_AAUDIO_LOW_LATENCY)

  # set this definition to enable power saving mode. Possibly resulting
  # in high latency
  # target_compile_definitions(cubeb PRIVATE CUBEB_AAUDIO_LOW_POWER_SAVING)

  # set this mode to make the backend use an exclusive stream.
  # will decrease latency.
  # target_compile_definitions(cubeb PRIVATE CUBEB_AAUDIO_EXCLUSIVE_STREAM)

  target_link_libraries(cubeb PRIVATE ${CMAKE_DL_LIBS})
endif()

check_include_files(android/log.h USE_AUDIOTRACK)
if(USE_AUDIOTRACK)
  target_sources(cubeb PRIVATE
    src/cubeb_audiotrack.c)
  target_compile_definitions(cubeb PRIVATE USE_AUDIOTRACK)
  target_link_libraries(cubeb PRIVATE log)
endif()

check_include_files(sndio.h USE_SNDIO)
if(USE_SNDIO)
  target_sources(cubeb PRIVATE
    src/cubeb_sndio.c)
  target_compile_definitions(cubeb PRIVATE USE_SNDIO)
  target_link_libraries(cubeb PRIVATE pthread ${CMAKE_DL_LIBS})
endif()

check_include_files(sys/audioio.h USE_SUN)
if(USE_SUN)
  target_sources(cubeb PRIVATE
    src/cubeb_sun.c)
  target_compile_definitions(cubeb PRIVATE USE_SUN)
  target_link_libraries(cubeb PRIVATE pthread)
endif()

check_include_files(kai.h USE_KAI)
if(USE_KAI)
  target_sources(cubeb PRIVATE
    src/cubeb_kai.c)
  target_compile_definitions(cubeb PRIVATE USE_KAI)
  target_link_libraries(cubeb PRIVATE kai)
endif()

if(USE_PULSE AND USE_PULSE_RUST)
  include(ExternalProject)
  set_directory_properties(PROPERTIES EP_PREFIX ${CMAKE_BINARY_DIR}/rust)
  ExternalProject_Add(
    cubeb_pulse_rs
    DOWNLOAD_COMMAND ""
    CONFIGURE_COMMAND ""
    BUILD_COMMAND cargo build COMMAND cargo build --release
    BUILD_ALWAYS ON
    BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs"
    INSTALL_COMMAND ""
    LOG_BUILD ON)
  add_dependencies(cubeb cubeb_pulse_rs)
  target_compile_definitions(cubeb PRIVATE USE_PULSE_RUST)
  target_link_libraries(cubeb PRIVATE
    debug "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs/target/debug/libcubeb_pulse.a"
    optimized "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs/target/release/libcubeb_pulse.a" pulse)
endif()

if(USE_AUDIOUNIT AND USE_AUDIOUNIT_RUST)
  include(ExternalProject)
  set_directory_properties(PROPERTIES EP_PREFIX ${CMAKE_BINARY_DIR}/rust)
  ExternalProject_Add(
    cubeb_coreaudio_rs
    DOWNLOAD_COMMAND ""
    CONFIGURE_COMMAND ""
    BUILD_COMMAND cargo build COMMAND cargo build --release
    BUILD_ALWAYS ON
    BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs"
    INSTALL_COMMAND ""
    LOG_BUILD ON)
  add_dependencies(cubeb cubeb_coreaudio_rs)
  target_compile_definitions(cubeb PRIVATE USE_AUDIOUNIT_RUST)
  target_link_libraries(cubeb PRIVATE
    debug "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs/target/debug/libcubeb_coreaudio.a"
    optimized "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs/target/release/libcubeb_coreaudio.a")
endif()

find_package(Doxygen)
if(DOXYGEN_FOUND)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/docs/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/docs/Doxyfile @ONLY)
  add_custom_target(doc ALL
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/docs/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docs
    COMMENT "Generating API documentation with Doxygen" VERBATIM)
endif()

if(BUILD_TESTS)
  enable_testing()

  macro(cubeb_add_test NAME)
    add_executable(test_${NAME} test/test_${NAME}.cpp)
    target_include_directories(test_${NAME} PRIVATE ${gtest_SOURCE_DIR}/include)
    target_include_directories(test_${NAME} PRIVATE src)
    target_link_libraries(test_${NAME} PRIVATE cubeb gtest_main)
    add_test(${NAME} test_${NAME})
    add_sanitizers(test_${NAME})
    install(TARGETS test_${NAME} DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR})
  endmacro(cubeb_add_test)

  cubeb_add_test(sanity)
  cubeb_add_test(tone)
  cubeb_add_test(audio)
  cubeb_add_test(record)
  cubeb_add_test(devices)
  cubeb_add_test(callback_ret)

  add_executable(test_resampler test/test_resampler.cpp src/cubeb_resampler.cpp $<TARGET_OBJECTS:speex>)
  target_include_directories(test_resampler PRIVATE ${gtest_SOURCE_DIR}/include)
  target_include_directories(test_resampler PRIVATE src)
  target_compile_definitions(test_resampler PRIVATE OUTSIDE_SPEEX)
  target_compile_definitions(test_resampler PRIVATE FLOATING_POINT)
  target_compile_definitions(test_resampler PRIVATE EXPORT=)
  target_compile_definitions(test_resampler PRIVATE RANDOM_PREFIX=speex)
  target_link_libraries(test_resampler PRIVATE cubeb gtest_main)
  add_test(resampler test_resampler)
  add_sanitizers(test_resampler)
  install(TARGETS test_resampler DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR})

  cubeb_add_test(duplex)

  if (USE_WASAPI)
    cubeb_add_test(overload_callback)

=== debian/changelog ===
cubeb (0.0~git20211015.d512bfa+ds-1) unstable; urgency=medium

  * Initial release. Closes: #995059

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 17 Oct 2021 17:01:28 +0000

=== debian/control ===
Source: cubeb
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: cmake (>= 3.1), debhelper-compat (= 13)
Build-Depends-Arch: libasound2-dev,
                    libjack-jackd2-dev,
                    libpulse-dev,
                    libsndio-dev,
                    libspeexdsp-dev,
                    pkg-config
Standards-Version: 4.6.0
Homepage: https://github.com/mozilla/cubeb
Rules-Requires-Root: no

Package: libcubeb0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: cross platform audio library
 cubeb is a cross platform audio library most notable for its use as
 the audio backend within Gecko, Mozilla's browser engine. It supports
 multiple audio backends and allows enumeration of audio devices and
 opening audio streams with control over latency, sample rate and more.
 .
 This package contains the shared library.

Package: libcubeb-dev
Section: libdevel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libcubeb0 (= ${binary:Version}),
         libspeexdsp-dev,
         ${misc:Depends}
Description: cross platform audio library - development files
 cubeb is a cross platform audio library most notable for its use as
 the audio backend within Gecko, Mozilla's browser engine. It supports
 multiple audio backends and allows enumeration of audio devices and
 opening audio streams with control over latency, sample rate and more.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export LC_ALL = C.UTF-8

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_TARGET_MULTIARCH)" \
		-DBUILD_SHARED_LIBS=ON \
		-DBUILD_TESTS=OFF \
		-DBUILD_RUST_LIBS=OFF \
		-DBUILD_TOOLS=OFF \
		-DLAZY_LOAD_LIBS=OFF \
		-DUSE_SANITIZERS=OFF

## cubeb 0.0~git20211203.75d9d12+ds

=== CMakeLists.txt ===
# TODO
# - backend selection via command line, rather than simply detecting headers.

cmake_minimum_required(VERSION 3.14 FATAL_ERROR)
project(cubeb
  VERSION 0.0.0)

option(BUILD_SHARED_LIBS "Build shared libraries" OFF)
option(BUILD_TESTS "Build tests" ON)
option(BUILD_RUST_LIBS "Build rust backends" OFF)
option(BUILD_TOOLS "Build tools" ON)
option(BUNDLE_SPEEX "Bundle the speex library" OFF)
option(LAZY_LOAD_LIBS "Lazily load shared libraries" ON)
option(USE_SANITIZERS "Use sanitizers" ON)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
      "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(USE_SANITIZERS)
  if(NOT COMMAND add_sanitizers)
    list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/sanitizers-cmake/cmake")
    find_package(Sanitizers)
    if(NOT COMMAND add_sanitizers)
      message(FATAL_ERROR "Could not find sanitizers-cmake: run\n\tgit submodule update --init --recursive\nin base git checkout")
    endif()
  endif()
else()
  macro(add_sanitizers UNUSED)
  endmacro()
endif()

if(BUILD_TESTS)
  find_package(GTest QUIET)
  if(TARGET GTest::Main)
    add_library(gtest_main ALIAS GTest::Main)
  endif()
  if(NOT TARGET gtest_main)
    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/googletest/CMakeLists.txt")
      message(FATAL_ERROR "Could not find googletest: run\n\tgit submodule update --init --recursive\nin base git checkout")
    endif()
    add_definitions(-DGTEST_HAS_TR1_TUPLE=0 -DGTEST_HAS_RTTI=0)
    set(gtest_force_shared_crt ON CACHE BOOL "")
    add_subdirectory(googletest)
  endif()
endif()

if (BUILD_RUST_LIBS)
  if(EXISTS "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs")
    set(USE_PULSE_RUST 1)
  endif()
  if(EXISTS "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs")
    set(USE_AUDIOUNIT_RUST 1)
  endif()
endif()

# On OS/2, visibility attribute is not supported.
if(NOT OS2)
  set(CMAKE_C_VISIBILITY_PRESET hidden)
  set(CMAKE_CXX_VISIBILITY_PRESET hidden)
  set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
endif()

set(CMAKE_CXX_WARNING_LEVEL 4)
if(NOT MSVC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-unused-parameter")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -fno-exceptions -fno-rtti")
else()
  string(REPLACE "/GR" "" CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS}) # Disable RTTI
  string(REPLACE "/EHsc" "" CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS}) # Disable Exceptions
endif()

add_library(cubeb
  src/cubeb.c
  src/cubeb_mixer.cpp
  src/cubeb_resampler.cpp
  src/cubeb_log.cpp
  src/cubeb_strings.c
  src/cubeb_utils.cpp
)
target_include_directories(cubeb
  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>
)
set_target_properties(cubeb PROPERTIES
  VERSION ${cubeb_VERSION}
  SOVERSION ${cubeb_VERSION_MAJOR}
)

add_sanitizers(cubeb)

include(GenerateExportHeader)
generate_export_header(cubeb EXPORT_FILE_NAME ${CMAKE_BINARY_DIR}/exports/cubeb_export.h)
target_include_directories(cubeb
  PUBLIC $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/exports>
)

include(GNUInstallDirs)

install(DIRECTORY ${CMAKE_SOURCE_DIR}/include/${PROJECT_NAME} TYPE INCLUDE)
install(DIRECTORY ${CMAKE_BINARY_DIR}/exports/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
  COMPATIBILITY SameMajorVersion
)

configure_package_config_file(
  "Config.cmake.in"
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
  INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

install(
  FILES "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake" "${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

install(TARGETS cubeb EXPORT "${PROJECT_NAME}Targets")
install(
  EXPORT "${PROJECT_NAME}Targets"
  NAMESPACE "${PROJECT_NAME}::"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

if(NOT BUNDLE_SPEEX)
  find_package(PkgConfig)
  if(PKG_CONFIG_FOUND)
    pkg_check_modules(speexdsp IMPORTED_TARGET speexdsp)
    if(speexdsp_FOUND)
      add_library(speex ALIAS PkgConfig::speexdsp)
    endif()
  endif()
endif()

if(NOT TARGET speex)
  add_library(speex STATIC subprojects/speex/resample.c)
  set_target_properties(speex PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
  target_include_directories(speex INTERFACE subprojects)
  target_compile_definitions(speex PUBLIC
    OUTSIDE_SPEEX
    FLOATING_POINT
    EXPORT=
    RANDOM_PREFIX=speex
  )
endif()

# $<BUILD_INTERFACE:> required because of https://gitlab.kitware.com/cmake/cmake/-/issues/15415
target_link_libraries(cubeb PRIVATE $<BUILD_INTERFACE:speex>)

include(CheckIncludeFiles)

# Threads needed by cubeb_log, _pulse, _alsa, _jack, _sndio, _oss and _sun
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads)
target_link_libraries(cubeb PRIVATE Threads::Threads)

if(LAZY_LOAD_LIBS)
  check_include_files(pulse/pulseaudio.h USE_PULSE)
  check_include_files(alsa/asoundlib.h   USE_ALSA)
  check_include_files(jack/jack.h        USE_JACK)
  check_include_files(sndio.h            USE_SNDIO)
  check_include_files(aaudio/AAudio.h    USE_AAUDIO)

  if(USE_PULSE OR USE_ALSA OR USE_JACK OR USE_SNDIO OR USE_AAUDIO)
    target_link_libraries(cubeb PRIVATE ${CMAKE_DL_LIBS})
  endif()

else()

  find_package(PkgConfig REQUIRED)

  pkg_check_modules(libpulse IMPORTED_TARGET libpulse)
  if(libpulse_FOUND)
    set(USE_PULSE ON)
    target_compile_definitions(cubeb PRIVATE DISABLE_LIBPULSE_DLOPEN)
    target_link_libraries(cubeb PRIVATE PkgConfig::libpulse)
  endif()

  pkg_check_modules(alsa IMPORTED_TARGET alsa)
  if(alsa_FOUND)
    set(USE_ALSA ON)
    target_compile_definitions(cubeb PRIVATE DISABLE_LIBASOUND_DLOPEN)
    target_link_libraries(cubeb PRIVATE PkgConfig::alsa)
  endif()

  pkg_check_modules(jack IMPORTED_TARGET jack)
  if(jack_FOUND)
    set(USE_JACK ON)
    target_compile_definitions(cubeb PRIVATE DISABLE_LIBJACK_DLOPEN)
    target_link_libraries(cubeb PRIVATE PkgConfig::jack)
  endif()

  check_include_files(sndio.h USE_SNDIO)
  if(USE_SNDIO)
    target_compile_definitions(cubeb PRIVATE DISABLE_LIBSNDIO_DLOPEN)
    target_link_libraries(cubeb PRIVATE sndio)
  endif()

  check_include_files(aaudio/AAudio.h USE_AAUDIO)
  if(USE_AAUDIO)
    target_compile_definitions(cubeb PRIVATE DISABLE_LIBAAUDIO_DLOPEN)
    target_link_libraries(cubeb PRIVATE aaudio)
  endif()
endif()

if(USE_PULSE)
  target_sources(cubeb PRIVATE src/cubeb_pulse.c)
  target_compile_definitions(cubeb PRIVATE USE_PULSE)
endif()

if(USE_ALSA)
  target_sources(cubeb PRIVATE src/cubeb_alsa.c)
  target_compile_definitions(cubeb PRIVATE USE_ALSA)
endif()

if(USE_JACK)
  target_sources(cubeb PRIVATE src/cubeb_jack.cpp)
  target_compile_definitions(cubeb PRIVATE USE_JACK)
endif()

if(USE_SNDIO)
  target_sources(cubeb PRIVATE src/cubeb_sndio.c)
  target_compile_definitions(cubeb PRIVATE USE_SNDIO)
endif()

if(USE_AAUDIO)
  target_sources(cubeb PRIVATE src/cubeb_aaudio.cpp)
  target_compile_definitions(cubeb PRIVATE USE_AAUDIO)

  # set this definition to enable low latency mode. Possibly bad for battery
  target_compile_definitions(cubeb PRIVATE CUBEB_AAUDIO_LOW_LATENCY)

  # set this definition to enable power saving mode. Possibly resulting
  # in high latency
  # target_compile_definitions(cubeb PRIVATE CUBEB_AAUDIO_LOW_POWER_SAVING)

  # set this mode to make the backend use an exclusive stream.
  # will decrease latency.
  # target_compile_definitions(cubeb PRIVATE CUBEB_AAUDIO_EXCLUSIVE_STREAM)
endif()

check_include_files(AudioUnit/AudioUnit.h USE_AUDIOUNIT)
if(USE_AUDIOUNIT)
  target_sources(cubeb PRIVATE
    src/cubeb_audiounit.cpp
    src/cubeb_osx_run_loop.cpp)
  target_compile_definitions(cubeb PRIVATE USE_AUDIOUNIT)
  target_link_libraries(cubeb PRIVATE "-framework AudioUnit" "-framework CoreAudio" "-framework CoreServices")
endif()

check_include_files(audioclient.h USE_WASAPI)
if(USE_WASAPI)
  target_sources(cubeb PRIVATE
    src/cubeb_wasapi.cpp)
  target_compile_definitions(cubeb PRIVATE USE_WASAPI)
  target_link_libraries(cubeb PRIVATE avrt ole32)
endif()

check_include_files("windows.h;mmsystem.h" USE_WINMM)
if(USE_WINMM)
  target_sources(cubeb PRIVATE
    src/cubeb_winmm.c)
  target_compile_definitions(cubeb PRIVATE USE_WINMM)
  target_link_libraries(cubeb PRIVATE winmm)
endif()

check_include_files(SLES/OpenSLES.h USE_OPENSL)
if(USE_OPENSL)
  target_sources(cubeb PRIVATE
    src/cubeb_opensl.c
    src/cubeb-jni.cpp)
  target_compile_definitions(cubeb PRIVATE USE_OPENSL)
  target_link_libraries(cubeb PRIVATE OpenSLES)
endif()

check_include_files(sys/soundcard.h HAVE_SYS_SOUNDCARD_H)
if(HAVE_SYS_SOUNDCARD_H)
  try_compile(USE_OSS "${PROJECT_BINARY_DIR}/compile_tests"
    ${PROJECT_SOURCE_DIR}/cmake/compile_tests/oss_is_v4.c)
  if(USE_OSS)
    target_sources(cubeb PRIVATE
      src/cubeb_oss.c)
    target_compile_definitions(cubeb PRIVATE USE_OSS)
  endif()
endif()

check_include_files(android/log.h USE_AUDIOTRACK)
if(USE_AUDIOTRACK)
  target_sources(cubeb PRIVATE
    src/cubeb_audiotrack.c)
  target_compile_definitions(cubeb PRIVATE USE_AUDIOTRACK)
  target_link_libraries(cubeb PRIVATE log)
endif()

check_include_files(sys/audioio.h USE_SUN)
if(USE_SUN)
  target_sources(cubeb PRIVATE
    src/cubeb_sun.c)
  target_compile_definitions(cubeb PRIVATE USE_SUN)
endif()

check_include_files(kai.h USE_KAI)
if(USE_KAI)
  target_sources(cubeb PRIVATE
    src/cubeb_kai.c)
  target_compile_definitions(cubeb PRIVATE USE_KAI)
  target_link_libraries(cubeb PRIVATE kai)
endif()

if(USE_PULSE AND USE_PULSE_RUST)
  include(ExternalProject)
  set_directory_properties(PROPERTIES EP_PREFIX ${CMAKE_BINARY_DIR}/rust)
  ExternalProject_Add(
    cubeb_pulse_rs
    DOWNLOAD_COMMAND ""
    CONFIGURE_COMMAND ""
    BUILD_COMMAND cargo build COMMAND cargo build --release
    BUILD_ALWAYS ON
    BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs"
    INSTALL_COMMAND ""
    LOG_BUILD ON)
  add_dependencies(cubeb cubeb_pulse_rs)
  target_compile_definitions(cubeb PRIVATE USE_PULSE_RUST)
  target_link_libraries(cubeb PRIVATE
    debug "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs/target/debug/libcubeb_pulse.a"
    optimized "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs/target/release/libcubeb_pulse.a" pulse)
endif()

if(USE_AUDIOUNIT AND USE_AUDIOUNIT_RUST)
  include(ExternalProject)
  set_directory_properties(PROPERTIES EP_PREFIX ${CMAKE_BINARY_DIR}/rust)
  ExternalProject_Add(
    cubeb_coreaudio_rs
    DOWNLOAD_COMMAND ""
    CONFIGURE_COMMAND ""
    BUILD_COMMAND cargo build COMMAND cargo build --release
    BUILD_ALWAYS ON
    BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs"
    INSTALL_COMMAND ""
    LOG_BUILD ON)
  add_dependencies(cubeb cubeb_coreaudio_rs)
  target_compile_definitions(cubeb PRIVATE USE_AUDIOUNIT_RUST)
  target_link_libraries(cubeb PRIVATE
    debug "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs/target/debug/libcubeb_coreaudio.a"
    optimized "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs/target/release/libcubeb_coreaudio.a")
endif()

find_package(Doxygen)
if(DOXYGEN_FOUND)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/docs/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/docs/Doxyfile @ONLY)
  add_custom_target(doc ALL
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/docs/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docs
    COMMENT "Generating API documentation with Doxygen" VERBATIM)
endif()

if(BUILD_TESTS)
  enable_testing()

  macro(cubeb_add_test NAME)
    add_executable(test_${NAME} test/test_${NAME}.cpp)
    target_include_directories(test_${NAME} PRIVATE ${gtest_SOURCE_DIR}/include src)
    target_link_libraries(test_${NAME} PRIVATE cubeb gtest_main)
    add_test(${NAME} test_${NAME})
    add_sanitizers(test_${NAME})
    install(TARGETS test_${NAME})
  endmacro(cubeb_add_test)

  cubeb_add_test(sanity)

=== debian/changelog ===
cubeb (0.0~git20211203.75d9d12+ds-1) unstable; urgency=medium

  * New upstream release.
  * d/control: add Vcs fields
  * d/patches: drop upstreamed patches
  * d/rules: add qa=+all option

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 06 Dec 2021 20:03:28 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,8 @@
 Section: libs
 Priority: optional
 Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
-Build-Depends: cmake (>= 3.1), debhelper-compat (= 13)
+Build-Depends: cmake (>= 3.1),
+               debhelper-compat (= 13)
 Build-Depends-Arch: libasound2-dev,
                     libjack-jackd2-dev,
                     libpulse-dev,
@@ -11,12 +12,15 @@
                     pkg-config
 Standards-Version: 4.6.0
 Homepage: https://github.com/mozilla/cubeb
+Vcs-Git: https://salsa.debian.org/debian/cubeb.git
+Vcs-Browser: https://salsa.debian.org/debian/cubeb
 Rules-Requires-Root: no
 
 Package: libcubeb0
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Description: cross platform audio library
  cubeb is a cross platform audio library most notable for its use as
  the audio backend within Gecko, Mozilla's browser engine. It supports

## cubeb 0.0~git20211207.773f16b+ds

=== debian/changelog ===
cubeb (0.0~git20211207.773f16b+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20211207.773f16b
  * d/control: only enable ALSA backend on Linux
  * d/gbp.conf: use pbuilder

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 30 Dec 2021 14:11:12 +0100

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,13 @@
 Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
 Build-Depends: cmake (>= 3.1),
                debhelper-compat (= 13)
-Build-Depends-Arch: libasound2-dev,
+Build-Depends-Arch: libasound2-dev [linux-any],
                     libjack-jackd2-dev,
                     libpulse-dev,
                     libsndio-dev,
                     libspeexdsp-dev,
                     pkg-config
+Build-Conflicts-Arch: libasound2-dev [!linux-any]
 Standards-Version: 4.6.0
 Homepage: https://github.com/mozilla/cubeb
 Vcs-Git: https://salsa.debian.org/debian/cubeb.git

## cubeb 0.0~git20220110.9edd150+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -259,7 +259,7 @@
   target_sources(cubeb PRIVATE
     src/cubeb_wasapi.cpp)
   target_compile_definitions(cubeb PRIVATE USE_WASAPI)
-  target_link_libraries(cubeb PRIVATE avrt ole32)
+  target_link_libraries(cubeb PRIVATE avrt ole32 ksuser)
 endif()
 
 check_include_files("windows.h;mmsystem.h" USE_WINMM)

=== debian/changelog ===
cubeb (0.0~git20220110.9edd150+ds-1ubuntu2) jammy; urgency=medium

  * Rebuild against new old libsndio7.0.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 12 Mar 2022 05:59:13 +0100

cubeb (0.0~git20220110.9edd150+ds-1ubuntu1) jammy; urgency=medium

  * Mark one symbol as optional 

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 07 Mar 2022 12:14:53 +0100

cubeb (0.0~git20220110.9edd150+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20220110.9edd150
  * d/patches: use libbsd when using OSS and glibc

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 12 Jan 2022 19:29:06 +0100

## cubeb 0.0~git20220309.6e5b9fe+ds

=== debian/changelog ===
cubeb (0.0~git20220309.6e5b9fe+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20220309.6e5b9fe+ds
  * d/tests: add autopkgtests
  * d/patches: drop upstreamed patches
  * d/libcubeb0.symbols: mark c++ symbol as optional.
    Thanks to Gianfranco Costamagna for the patch (Closes: 1006877)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 11 Mar 2022 23:02:08 +0100

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Build-Depends: cmake (>= 3.1),
                debhelper-compat (= 13)
 Build-Depends-Arch: libasound2-dev [linux-any],
+                    libbsd-dev [kfreebsd-any],
                     libjack-jackd2-dev,
                     libpulse-dev,
                     libsndio-dev,

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all qa=+all
export LC_ALL = C.UTF-8

%:
	dh $@

# Tests can't be ran because they require access to the host's audio
# peripherals, and for some reason it seems that the tests can't access
# them when ran under debuild
override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DBUILD_TESTS=OFF \
		-DBUILD_RUST_LIBS=OFF \
		-DBUILD_TOOLS=OFF \
		-DBUNDLE_SPEEX=OFF \
		-DLAZY_LOAD_LIBS=OFF \
		-DUSE_SANITIZERS=OFF

=== debian/tests/control ===
Tests: compile
Depends: @, cmake, g++ | c++-compiler

## cubeb 0.0~git20220413.708f52c+ds

=== debian/changelog ===
cubeb (0.0~git20220413.708f52c+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20220413.708f52c+ds
  * d/control: mark as Multi-Arch: same
  * d/rules: disable qa=+canary to work around #1009408

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 15 Apr 2022 18:06:26 +0200

=== debian/control ===
--- 
+++ 
@@ -20,6 +20,7 @@
 
 Package: libcubeb0
 Architecture: any
+Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends},
          ${shlibs:Depends}
@@ -34,6 +35,7 @@
 Package: libcubeb-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: libcubeb0 (= ${binary:Version}),
          libspeexdsp-dev,

## cubeb 0.0~git20220721.dc511c6+ds

=== debian/changelog ===
cubeb (0.0~git20220721.dc511c6+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20220721.dc511c6+ds
  * d/control: build-depend on CMake 3.14

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 19 Aug 2022 01:23:19 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: libs
 Priority: optional
 Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
-Build-Depends: cmake (>= 3.1),
-               debhelper-compat (= 13)
-Build-Depends-Arch: libasound2-dev [linux-any],
+Build-Depends: debhelper-compat (= 13)
+Build-Depends-Arch: cmake (>= 3.14),
+                    libasound2-dev [linux-any],
                     libbsd-dev [kfreebsd-any],
                     libjack-jackd2-dev,
                     libpulse-dev,
@@ -12,7 +12,7 @@
                     libspeexdsp-dev,
                     pkg-config
 Build-Conflicts-Arch: libasound2-dev [!linux-any]
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/mozilla/cubeb
 Vcs-Git: https://salsa.debian.org/debian/cubeb.git
 Vcs-Browser: https://salsa.debian.org/debian/cubeb

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all qa=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all qa=+all,-canary
 export LC_ALL = C.UTF-8
 
 %:

## cubeb 0.0~git20220930.6b474ee+ds

=== debian/changelog ===
cubeb (0.0~git20220930.6b474ee+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20220930.6b474ee+ds

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 04 Oct 2022 10:51:09 +0200

cubeb (0.0~git20220922.93d1fa3+ds-2) unstable; urgency=medium

  * d/control: fix arch all build

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 29 Sep 2022 20:12:23 +0200

cubeb (0.0~git20220922.93d1fa3+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20220922.93d1fa3+ds
  * d/control: add libcubeb-doc package.
    This new package contains Doxygen-generated API documentation

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 25 Sep 2022 19:14:15 +0200

cubeb (0.0~git20220906.4783607+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20220906.4783607+ds
  * d/rules: enable LTO

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 09 Sep 2022 13:39:33 +0200

## cubeb 0.0~git20221018.27d2a10+ds

=== debian/changelog ===
cubeb (0.0~git20221018.27d2a10+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20221018.27d2a10+ds

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sat, 29 Oct 2022 22:59:16 +0200

=== debian/control ===
--- 
+++ 
@@ -11,6 +11,11 @@
                     libsndio-dev,
                     libspeexdsp-dev,
                     pkg-config
+Build-Depends-Indep: cmake (>= 3.14),
+                     doxygen <!nodoc>,
+                     graphviz <!nodoc>,
+                     libspeexdsp-dev,
+                     pkg-config
 Build-Conflicts-Arch: libasound2-dev [!linux-any]
 Standards-Version: 4.6.1
 Homepage: https://github.com/mozilla/cubeb
@@ -40,6 +45,7 @@
 Depends: libcubeb0 (= ${binary:Version}),
          libspeexdsp-dev,
          ${misc:Depends}
+Recommends: libcubeb-doc
 Description: cross platform audio library - development files
  cubeb is a cross platform audio library most notable for its use as
  the audio backend within Gecko, Mozilla's browser engine. It supports
@@ -47,3 +53,17 @@
  opening audio streams with control over latency, sample rate and more.
  .
  This package contains the development files.
+
+Package: libcubeb-doc
+Section: doc
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Recommends: libjs-jquery
+Description: cross platform audio library - documentation
+ cubeb is a cross platform audio library most notable for its use as
+ the audio backend within Gecko, Mozilla's browser engine. It supports
+ multiple audio backends and allows enumeration of audio devices and
+ opening audio streams with control over latency, sample rate and more.
+ .
+ This package contains the generated Doxygen documentation.

=== debian/rules ===
#!/usr/bin/make -f

# optimize=-lto because I use CMake's LTO
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto qa=+all
export LC_ALL = C.UTF-8

%:
	dh $@

# Tests can't be run because they require access to the host's audio
# peripherals, and for some reason it seems that the tests can't access
# them when ran under debuild
configure_flags := -DCMAKE_INTERPROCEDURAL_OPTIMIZATION=ON \
  -DBUILD_SHARED_LIBS=ON \
  -DBUILD_TESTS=OFF \
  -DBUILD_RUST_LIBS=OFF \
  -DBUILD_TOOLS=OFF \
  -DBUNDLE_SPEEX=OFF \
  -DUSE_SANITIZERS=OFF

override_dh_auto_configure-arch:
	dh_auto_configure --arch -- $(configure_flags) -DLAZY_LOAD_LIBS=OFF

override_dh_auto_configure-indep:
	dh_auto_configure --indep -- $(configure_flags)

# Only building the doc target would require using cmake --install --component,
# and this isn't currently easily possible with debhelper (see #1020732)
#override_dh_auto_build-indep:
#	dh_auto_build --indep -- doc
#
#override_dh_auto_install-indep:
#	dh_auto_install --indep -- --component=Documentation

override_dh_installdocs-indep:
	dh_installdocs --indep --doc-main-package=libcubeb-doc

# https://salsa.debian.org/debian/doxygen/-/blob/3be8390e2d89f79300c5d3f69619d37979a8a180/debian/dh-doxygen/doxygen.pm
# https://bugs.debian.org/799543#37
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
execute_after_dh_installdocs-indep:
	dh_doxygen --indep
endif

## cubeb 0.0~git20221207.51728e5+ds

=== debian/changelog ===
cubeb (0.0~git20221207.51728e5+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20221207.51728e5+ds
  * d/control: stop splitting arch and indep b-depends
  * d/rules: install documentation in the -dev docdir

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 08 Dec 2022 17:53:32 +0100

## cubeb 0.0~git20221213.e4da2d4+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -139,7 +139,7 @@
 endif()
 
 if(NOT TARGET speex)
-  add_library(speex STATIC subprojects/speex/resample.c)
+  add_library(speex OBJECT subprojects/speex/resample.c)
   set_target_properties(speex PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
   target_include_directories(speex INTERFACE subprojects)
   target_compile_definitions(speex PUBLIC
@@ -284,9 +284,22 @@
   try_compile(USE_OSS "${PROJECT_BINARY_DIR}/compile_tests"
     ${PROJECT_SOURCE_DIR}/cmake/compile_tests/oss_is_v4.c)
   if(USE_OSS)
-    target_sources(cubeb PRIVATE
-      src/cubeb_oss.c)
-    target_compile_definitions(cubeb PRIVATE USE_OSS)
+    # strlcpy is not available on BSD systems that use glibc,
+    # like Debian kfreebsd, so try using libbsd if available
+    include(CheckSymbolExists)
+    check_symbol_exists(strlcpy string.h HAVE_STRLCPY)
+    if(NOT HAVE_STRLCPY)
+      pkg_check_modules(libbsd-overlay IMPORTED_TARGET libbsd-overlay)
+      if(libbsd-overlay_FOUND)
+        target_link_libraries(cubeb PRIVATE PkgConfig::libbsd-overlay)
+        set(HAVE_STRLCPY true)
+      endif()
+    endif()
+    if (HAVE_STRLCPY)
+      target_sources(cubeb PRIVATE
+        src/cubeb_oss.c)
+      target_compile_definitions(cubeb PRIVATE USE_OSS)
+    endif()
   endif()
 endif()
 
@@ -357,19 +370,3 @@
   add_custom_target(doc ALL
     ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/docs/Doxyfile
     WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docs
-    COMMENT "Generating API documentation with Doxygen" VERBATIM)
-endif()
-
-if(BUILD_TESTS)
-  enable_testing()
-
-  macro(cubeb_add_test NAME)
-    add_executable(test_${NAME} test/test_${NAME}.cpp)
-    target_include_directories(test_${NAME} PRIVATE ${gtest_SOURCE_DIR}/include src)
-    target_link_libraries(test_${NAME} PRIVATE cubeb gtest_main)
-    add_test(${NAME} test_${NAME})
-    add_sanitizers(test_${NAME})
-    install(TARGETS test_${NAME})
-  endmacro(cubeb_add_test)
-
-  cubeb_add_test(sanity)

=== debian/changelog ===
cubeb (0.0~git20221213.e4da2d4+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20221213.e4da2d4+ds

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 14 Dec 2022 13:57:56 +0100

=== debian/rules ===
#!/usr/bin/make -f

# optimize=-lto because I use CMake's LTO
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto qa=+all

%:
	dh $@

# Tests can't be run because they require access to the host's audio
# peripherals, and for some reason it seems that the tests can't access
# them when ran under debuild
override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INTERPROCEDURAL_OPTIMIZATION=ON \
		-DBUILD_SHARED_LIBS=ON \
		-DBUILD_RUST_LIBS=OFF \
		-DBUILD_TESTS=OFF \
		-DBUILD_TOOLS=OFF \
		-DBUNDLE_SPEEX=OFF \
		-DLAZY_LOAD_LIBS=OFF \
		-DUSE_SANITIZERS=OFF

# Only building the doc target would require using cmake --install --component,
# and this isn't currently easily possible with debhelper (see #1020732)
#override_dh_auto_build-indep:
#	dh_auto_build --indep -- doc
#
#override_dh_auto_install-indep:
#	dh_auto_install --indep -- --component=Documentation

# https://salsa.debian.org/debian/doxygen/-/blob/3be8390e2d89f79300c5d3f69619d37979a8a180/debian/dh-doxygen/doxygen.pm
# https://bugs.debian.org/799543#37
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
execute_after_dh_installdocs-indep:
	dh_doxygen --indep
endif

## cubeb 0.0~git20221214.dbc6033+ds

=== debian/changelog ===
cubeb (0.0~git20221214.dbc6033+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20221214.dbc6033+ds

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 15 Dec 2022 22:50:30 +0100

## cubeb 0.0~git20230105.1736e4a+ds

=== debian/changelog ===
cubeb (0.0~git20230105.1736e4a+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20230105.1736e4a+ds

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 09 Jan 2023 08:50:45 +0100

## cubeb 0.0~git20230109.c96f0d4+ds

=== debian/changelog ===
cubeb (0.0~git20230109.c96f0d4+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20230109.c96f0d4+ds

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 11 Jan 2023 12:38:35 +0100

## cubeb 0.0~git20230127.88585b6+ds

=== debian/changelog ===
cubeb (0.0~git20230127.88585b6+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20230127.88585b6+ds

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 30 Jan 2023 13:45:54 +0100

## cubeb 0.0~git20230201.70b4e3d+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -71,8 +71,8 @@
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-unused-parameter")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -fno-exceptions -fno-rtti")
 else()
-  string(REPLACE "/GR" "" CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS}) # Disable RTTI
-  string(REPLACE "/EHsc" "" CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS}) # Disable Exceptions
+  string(REPLACE "/GR" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}") # Disable RTTI
+  string(REPLACE "/EHsc" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}") # Disable Exceptions
 endif()
 
 add_library(cubeb
@@ -169,6 +169,10 @@
 
   if(USE_PULSE OR USE_ALSA OR USE_JACK OR USE_SNDIO OR USE_AAUDIO)
     target_link_libraries(cubeb PRIVATE ${CMAKE_DL_LIBS})
+
+    if(ANDROID)
+      target_compile_definitions(cubeb PRIVATE __ANDROID_UNAVAILABLE_SYMBOLS_ARE_WEAK__)
+    endif()
   endif()
 
 else()
@@ -368,5 +372,3 @@
 if(DOXYGEN_FOUND)
   configure_file(${CMAKE_CURRENT_SOURCE_DIR}/docs/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/docs/Doxyfile @ONLY)
   add_custom_target(doc ALL
-    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/docs/Doxyfile
-    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docs

=== debian/changelog ===
cubeb (0.0~git20230201.70b4e3d+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20230201.70b4e3d+ds
    - sndio: switch audio to 24-bit precision

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sat, 04 Feb 2023 02:32:35 +0100

=== debian/control ===
--- 
+++ 
@@ -2,21 +2,18 @@
 Section: libs
 Priority: optional
 Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
-Build-Depends: debhelper-compat (= 13)
-Build-Depends-Arch: cmake (>= 3.14),
-                    libasound2-dev [linux-any],
-                    libbsd-dev [kfreebsd-any],
-                    libjack-jackd2-dev,
-                    libpulse-dev,
-                    libsndio-dev,
-                    libspeexdsp-dev,
-                    pkg-config
-Build-Depends-Indep: cmake (>= 3.14),
-                     doxygen <!nodoc>,
-                     graphviz <!nodoc>,
-                     libspeexdsp-dev,
-                     pkg-config
-Build-Conflicts-Arch: libasound2-dev [!linux-any]
+Build-Depends: debhelper-compat (= 13),
+               cmake (>= 3.14),
+               doxygen <!nodoc>,
+               graphviz <!nodoc>,
+               libasound2-dev [linux-any],
+               libbsd-dev [kfreebsd-any],
+               libjack-jackd2-dev,
+               libpulse-dev,
+               libsndio-dev,
+               libspeexdsp-dev,
+               pkg-config
+Build-Conflicts: libasound2-dev [!linux-any]
 Standards-Version: 4.6.1
 Homepage: https://github.com/mozilla/cubeb
 Vcs-Git: https://salsa.debian.org/debian/cubeb.git

## cubeb 0.0~git20230825.3f86a06+ds

=== debian/changelog ===
cubeb (0.0~git20230825.3f86a06+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20230825.3f86a06+ds

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 12 Sep 2023 15:26:10 +0200

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                libspeexdsp-dev,
                pkg-config
 Build-Conflicts: libasound2-dev [!linux-any]
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/mozilla/cubeb
 Vcs-Git: https://salsa.debian.org/debian/cubeb.git
 Vcs-Browser: https://salsa.debian.org/debian/cubeb

## cubeb 0.0~git20240115.dd8a91f+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,8 +19,9 @@
 endif()
 
 set(CMAKE_C_STANDARD 99)
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 
 if(USE_SANITIZERS)
   if(NOT COMMAND add_sanitizers)
@@ -277,7 +278,7 @@
 check_include_files(SLES/OpenSLES.h USE_OPENSL)
 if(USE_OPENSL)
   target_sources(cubeb PRIVATE
-    src/cubeb_opensl.c
+    src/cubeb_opensl.cpp
     src/cubeb-jni.cpp)
   target_compile_definitions(cubeb PRIVATE USE_OPENSL)
   target_link_libraries(cubeb PRIVATE OpenSLES)
@@ -370,5 +371,3 @@
 
 find_package(Doxygen)
 if(DOXYGEN_FOUND)
-  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/docs/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/docs/Doxyfile @ONLY)
-  add_custom_target(doc ALL

=== debian/changelog ===
cubeb (0.0~git20240115.dd8a91f+ds-1build3) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 07 Apr 2024 07:11:15 +0000

cubeb (0.0~git20240115.dd8a91f+ds-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:50:02 +0000

cubeb (0.0~git20240115.dd8a91f+ds-1build1) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 06:31:13 +0000

cubeb (0.0~git20240115.dd8a91f+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20240115.dd8a91f+ds
    - Add new APIs for input processing
    - Add new API for muting the input side of a stream
  * d/.symbols: add three new symbols

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 16 Jan 2024 16:06:29 +0100

cubeb (0.0~git20240108.ffec8ed+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20240108.ffec8ed+ds
    - jack: fix a rare segmentation fault

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 12 Jan 2024 15:28:49 +0100

cubeb (0.0~git20231212.ed2efe2+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20231212.ed2efe2+ds

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 13 Dec 2023 15:31:21 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: cubeb
 Section: libs
 Priority: optional
-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
 Build-Depends: debhelper-compat (= 13),
                cmake (>= 3.14),
                doxygen <!nodoc>,
